package com.monnit.mine.SampleMineApplication;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.InetAddress;

import javax.swing.*;

import com.monnit.mine.MonnitMineAPI.Gateway;

public class FindGatewayPopup extends JFrame {
	public static Gateway gate;
	
	public static JPanel main;
		public static JPanel title;
			public static JLabel titleLabel;
			public static JLabel type;
			public static JLabel GatewayFirmware;
			public static JLabel RadioFirmware;
		public static JPanel config;
			public static JPanel hostPanel;
				public static JLabel hostLabel;
				public static JTextField hostField;
			public static JPanel portPanel;
				public static JLabel portLabel;
				public static JTextField portField;
			public static JPanel reportPanel;
				public static JLabel reportLabel;
				public static JTextField reportField;
			public static JButton updateConfig;

		
	public static Dimension mainDim = new Dimension(250, 275);
	public static Dimension titleDim = new Dimension(200, 70);
	public static Dimension rowDim = new Dimension(200, 25);
	public static Dimension halfRow = new Dimension(100, 25);
			
	public FindGatewayPopup(Gateway g) {
		super("Gateway");
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setPreferredSize(mainDim);
		
		gate = g;
		main = new JPanel();
		main.setLayout(new BoxLayout(main, BoxLayout.Y_AXIS));
		this.add(main);
		
		createTitle();
		createConfig1();
		
		main.setPreferredSize(mainDim);
		main.add(title);
		main.add(config);
		
		this.pack();
		this.setVisible(true);
	}
	
	public static void createTitle() {
		title = new JPanel();
		title.setLayout(new BoxLayout(title, BoxLayout.Y_AXIS));
		title.setPreferredSize(titleDim);
		
		titleLabel = new JLabel("GatewayID: " + gate.getGatewayID());
		titleLabel.setPreferredSize(rowDim);
		type = new JLabel(gate.getGatewayType().name());
		type.setPreferredSize(rowDim);
		GatewayFirmware = new JLabel("Gateway Firmware: " + gate.getGatewayFirmwareVersion());
		GatewayFirmware.setPreferredSize(rowDim);
		RadioFirmware = new JLabel("Radio Firmware: " + gate.getRadioFirmwareVersion());
		RadioFirmware.setPreferredSize(rowDim);
		
		title.add(titleLabel);
		title.add(type);
		title.add(GatewayFirmware);
		title.add(RadioFirmware);
	}
	
	public static void createConfig1() {
		config = new JPanel();
		config.setLayout(new BoxLayout(config, BoxLayout.Y_AXIS));
		
		
		hostPanel = new JPanel();
		hostPanel.setPreferredSize(rowDim);
			hostLabel = new JLabel("Host: ");
			hostField = new JTextField(""+gate.getServerHostAddress());
			hostField.setPreferredSize(halfRow);
			hostPanel.add(hostLabel);
			hostPanel.add(hostField);
		portPanel = new JPanel();
		portPanel.setPreferredSize(rowDim);
			portLabel = new JLabel("Port: ");
			portField = new JTextField(""+gate.getPort());
			portField.setPreferredSize(halfRow);
			portPanel.add(portLabel);
			portPanel.add(portField);	
		reportPanel = new JPanel();
		reportPanel.setPreferredSize(rowDim);
			reportLabel = new JLabel("Report Interval: ");
			reportField = new JTextField(""+gate.getReportInterval());
			reportField.setPreferredSize(halfRow);
			reportPanel.add(reportLabel);
			reportPanel.add(reportField);
		updateConfig = new JButton("Update");
		updateConfig.setPreferredSize(rowDim);
		updateConfig.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				gate.ServerHostAddress =getHost();
				gate.setPort(getPort());
				gate.UpdateReportInterval(getReportInterval());
				gate.IsDirty = true;
				GUIListenerFunctions.print("Updated Gateway.");
			}
		});
		
		config.add(hostPanel);
		config.add(portPanel);
		config.add(reportPanel);
		config.add(updateConfig);
	}
	
	public static String getHost() {
		try {
			String host = hostField.getText();
			InetAddress ip = InetAddress.getByName(host);
			return host;
		}
		catch (Exception e) {
			GUIListenerFunctions.print("Invalid Host. " + e.toString());
			hostField.setText(""+gate.getServerHostAddress());
			return gate.getServerHostAddress();
		}
	}
	
	public static int getPort() {
		try {
			return Integer.parseInt(portField.getText());
		}
		catch (Exception e) {
			GUIListenerFunctions.print("Invalid Port. " + e.toString());
			portField.setText(""+gate.getPort());
			return gate.getPort();			
		}
	}
	
	public static double getReportInterval() {
		try {
			return Double.parseDouble(reportField.getText());
		}
		catch (Exception e) {
			GUIListenerFunctions.print("Invalid Report Interval. " + e.toString());
			reportField.setText(""+gate.getReportInterval());
			return gate.getReportInterval();
		}
	}
}
