package com.monnit.mine.SampleMineApplication;

import java.util.List;

import com.monnit.mine.BaseApplication.Datum;
import com.monnit.mine.MonnitMineAPI.Gateway;
import com.monnit.mine.MonnitMineAPI.Sensor;
import com.monnit.mine.MonnitMineAPI.SensorMessage;
import com.monnit.mine.MonnitMineAPI.iSensorMessageHandler;

public class SensorMessageHandler implements iSensorMessageHandler {

	@Override
	public void ProcessSensorMessages(List<SensorMessage> sensorMessageList, Gateway gateway) throws Exception {
		for(SensorMessage msg : sensorMessageList) {
			if(msg.getSensorID() == 289 || msg.getSensorID() == 244 || msg.getSensorID() == 53125) {
				continue;
			}
			if(msg.getSensorID() == 811 && msg.getState() == 2) {
				GUIListenerFunctions.print("GatewayAutoConfigTime: "+gateway.getAutoConfigTime());
			}
			
			if(msg.ProfileID > 65000)
			{
				Sensor sens = GUIListenerFunctions.FindSensorBySensorID(msg.SensorID);
				msg.ProfileID = sens.MonnitApplication.Value();
				
			}
			List<Datum> dataList = msg.getData();
			
			for (Datum data : dataList)
			{    double tempD = -10;
			     int tempI = -10;
				  Object value = data.Data;
                  if (value instanceof Double) {
                      tempD =(Double) value;
                    
                  } else if (value instanceof Integer) {
                      tempI = (Integer) value;
                    
                  }
                
                  GUIListenerFunctions.print("Data Foreach: double Value: "+tempD+", Int Value: "+ tempI);
			}
			
			GUIListenerFunctions.print(msg.toString());
		}
	}

}
