package com.monnit.mine.MineToCommand;

import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import javax.crypto.spec.SecretKeySpec;

import com.monnit.mine.BaseApplication.BitConverter;
import com.monnit.mine.BaseApplication.ExtensionMethods.Extensions;
import com.monnit.mine.BaseApplication.applicationclasses.Control_1Base;
import com.monnit.mine.MonnitMineAPI.*;
import com.monnit.mine.MonnitMineAPI.enums.*;

public class MineToCommand {
	static int port = 4000;
	static MineServer _Server;

	public static void main(String[] args) {
		eMineListenerProtocol Protocol;
		try {
			Protocol = eMineListenerProtocol.TCP;
			InetAddress ip = InetAddress.getByName("0.0.0.0");
			
			_Server = new MineServer(Protocol, ip, port);
			_Server.StartServer();
			System.out.println("Constructed Server.");
			
			if(_Server.addGatewayDataProcessingHandler(new GatewayMessageHandler())) System.out.println("Added GatewayHandler.");
			else System.out.println("Failed to add handler.");
			if(_Server.addSensorDataProcessingHandler(new SensorMessageHandler())) System.out.println("Added SensorHandler.");
			else System.out.println("Failed to add handler.");
			if(_Server.addExceptionProcessingHandler(new ExceptionHandler())) System.out.println("Added ExceptionHandler.");
			else System.out.println("Failed to add handler.");
			if(_Server.addPersistSensorHandler(new PersistSensorHandler())) System.out.println("Added PersistSensorHandler.");
			else System.out.println("Failed to add handler.");
			if(_Server.addPersistGatewayHandler(new PersistGatewayHandler())) System.out.println("Added PersistGatewayHandler.");
			else System.out.println("Failed to add handler.");
			
			///////////////////////////////////////////////////////////
			//         Ad-hoc sensors and gateways
			///////////////////////////////////////////////////////////
			
			Gateway ethGate = new Gateway(
					101908,
					eGatewayType.Ethernet_3_0
					);
			/*
			Gateway usbGate = new Gateway(
					9596,
					eGatewayType.USB
					);
*/
			List<Sensor> sensList = new ArrayList<Sensor>();
			sensList.add( new Sensor(
					39144,
					eSensorApplication.Button,
					"2.2.0.0"
					));
			sensList.add(new Sensor(
					505,
					eSensorApplication.Activity_Detection,
					"2.3.0.0"
					));
			sensList.add(new Sensor(
					542,
					eSensorApplication.Activity_Timer,
					"2.3.0.0"
					));
			sensList.add(new Sensor(
					19324,
					eSensorApplication.Control_2_Output,
					"2.3.0.0"
					));
			
			
					
			_Server.RegisterGateway(ethGate);
			//_Server.RegisterGateway(usbGate);
			for(Sensor s : sensList) {
				_Server.RegisterSensor(ethGate.GatewayID, s);
			}
			/*
			_Server.RegisterSensor(usbGate.GatewayID,  new Sensor(
					811,
					eSensorApplication.Button,
					"2.2.0.0"
					));
			_Server.RegisterSensor(usbGate.GatewayID,  new Sensor(
					943,
					eSensorApplication.Humidity,
					"2.2.0.0"
					));
			_Server.RegisterSensor(usbGate.GatewayID,  new Sensor(
					990,
					eSensorApplication.HorizonPulseCounter,
					"2.2.0.0"
					));
			_Server.RegisterSensor(usbGate.GatewayID,  new Sensor(
					227,
					eSensorApplication.Light_Detection,
					"2.2.0.0"
					));
			_Server.RegisterSensor(usbGate.GatewayID,  new Sensor(
					219,
					eSensorApplication.Activity_Number,
					"2.2.0.0"
					));
			*/

			//ethGate.UpdateServerInformation("192.168.1.130", port);
			//ethGate.UpdatePollInterval(1);
			//ethGate.UpdateReportInterval(1);			
			
			while(true) {
				try {/*
					System.out.println("Listening...");
					Socket clientSocket = socket.accept();
					InputStream inputStream = clientSocket.getInputStream();
					byte[] inboundBuffer = new byte[4096];
					while(true) {
						int bytesRead = inputStream.read(inboundBuffer, 0, 4096);
		                if (bytesRead <= 0) break;	//eof
						byte[] Message = new byte[bytesRead];
						System.arraycopy(inboundBuffer, 0, Message, 0, bytesRead);
						System.out.println("Initial Message: " + Extensions.hexStr(Message));
						byte[] response = _Server.ProcessBytes(Message);
						System.out.println("Response (Custom, using ProcessBytes): " + Extensions.hexStr(response));
						OutputStream outputStream = clientSocket.getOutputStream();
						outputStream.write(response, 0, response.length);
						outputStream.flush();
						System.out.println("Sent response through custom netcode.");
						
					}
					clientSocket.close();*/
				}
				catch (Exception e) {
					e.printStackTrace();
					continue;
				}
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return;
		}

		
	}
	

}
