package com.monnit.mine.BaseApplication;

import com.monnit.mine.BaseApplication.ExtensionMethods.Extensions;
import java.io.UnsupportedEncodingException;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.Arrays;

public class BitConverter
{
  public static byte[] getBytes(boolean x)
  {
    return new byte[] { (byte)(x ? 1 : 0) };
  }
  
  public static byte[] getBytes(char c)
  {
    return new byte[] { (byte)(c & 0xFF), (byte)(c >> '\b' & 0xFF) };
  }
  
  public static byte[] getBytes(double x)
  {
    return getBytes(Double.doubleToRawLongBits(x));
  }
  
  public static byte[] getBytes(short x)
  {
    return new byte[] { (byte)(x >>> 8), (byte)x };
  }
  
  public static byte[] getTwoBytes(long x)
  {
    byte[] b = new byte[2];
    ByteBuffer bb = ByteBuffer.wrap(b);
    bb.putChar((char)x);
    byte[] bswap = { bb.array()[1], bb.array()[0] };
   // Extensions.debug(x, 14);
   // Extensions.debug(bswap[0], 14);
   // Extensions.debug(bswap[1], 14);
    return bswap;
  }
  
  public static byte[] getFourBytes(int x)
  {
    byte[] b = new byte[4];
    ByteBuffer bb = ByteBuffer.wrap(b);
    bb.putInt(x);
    byte[] bswap = { bb.array()[3], bb.array()[2], 
      bb.array()[1], bb.array()[0] };
  //  Extensions.debug(x, 14);
  //  Extensions.debug(bswap[0], 14);
  // Extensions.debug(bswap[1], 14);
    return bswap;
  }
  
  public static byte[] getFourBytes(long x)
  {  
	 
	  ByteBuffer bb = ByteBuffer.wrap(new byte[8]);
	  bb.putLong(x);
	  
	   byte[] bswap = { bb.array()[7], bb.array()[6], 
			      bb.array()[5], bb.array()[4] };
	   
	  	  
   return bswap;
    
  }
  
  public static byte[] getBufferBytes(int x)
  {
    return ByteBuffer.allocate(x).array();
  }
  
  public static byte[] getBytes(int x)
  {
    return new byte[] { (byte)x, (byte)(x >>> 8), (byte)(x >>> 16), 
      (byte)(x >>> 24) };
  }
  
  public static byte[] getSixBytes(int x)
  {
    return new byte[] { (byte)(x >>> 40), (byte)(x >>> 32), 
      (byte)(x >>> 24), (byte)(x >>> 16), (byte)(x >>> 8), 
      (byte)x };
  }
  
  public static byte[] getBytes(long x)
  {
    return new byte[] { (byte)(int)(x >>> 56), (byte)(int)(x >>> 48), 
      (byte)(int)(x >>> 40), (byte)(int)(x >>> 32), (byte)(int)(x >>> 24), 
      (byte)(int)(x >>> 16), (byte)(int)(x >>> 8), (byte)(int)x };
  }
  
  public static int toInt32(byte[] b)
    throws Exception
  {
    return ToInt32(b);
  }
  
  public static int ToInt32(byte[] b)
    throws Exception
  {
    return toInt32(b, 0);
  }
  
  public static int ToInt64(int x)
  {
    return toInt64(x);
  }
  
  public static int toInt64(int x)
  {
    return x;
  }
  
  public static byte[] getBytes(float x)
  {
    return getBytes(Float.floatToRawIntBits(x));
  }
  
  public static byte[] getBytes(String x)
  {
    return x.getBytes();
  }
  
  public static long doubleToInt64Bits(double x)
  {
    return Double.doubleToRawLongBits(x);
  }
  
  public static double int64BitsToDouble(long x)
  {
    return x;
  }
  
  public boolean toBoolean(byte[] bytes, int index)
    throws Exception
  {
    if (bytes.length != 1) {
      throw new Exception(
        "The length of the byte array must be at least 1 byte long.");
    }
    return bytes[index] != 0;
  }
  
  public char toChar(byte[] bytes, int index)
    throws Exception
  {
    if (bytes.length != 2) {
      throw new Exception(
        "The length of the byte array must be at least 2 bytes long.");
    }
    return (char)((0xFF & bytes[index]) << 8 | (0xFF & bytes[(index + 1)]) << 0);
  }
  
  public static double ToDouble(byte[] bytes, int index)
    throws Exception
  {
    return Double.longBitsToDouble(toInt64(bytes, index));
  }
  
  public static double toDouble(byte[] bytes, int index)
    throws Exception
  {
    if (bytes.length != 8) {
      throw new Exception(
        "The length of the byte array must be at least 8 bytes long.");
    }
    return Double.longBitsToDouble(toInt64(bytes, index));
  }
  
  public static Boolean toBool(byte[] bytes, int index)
    throws Exception
  {
    if ((bytes[index] & 0xFF) != 0) {
      return Boolean.valueOf(true);
    }
    return Boolean.valueOf(false);
  }
  
  public static Boolean toBool(byte byteob)
    throws Exception
  {
    if ((byteob & 0xFF) != 0) {
      return Boolean.valueOf(true);
    }
    return Boolean.valueOf(false);
  }
  
  public static Boolean ToBoolean(byte byteob)
    throws Exception
  {
    if ((byteob & 0xFF) != 0) {
      return Boolean.valueOf(true);
    }
    return Boolean.valueOf(false);
  }
  
  public static short toInt16(byte[] bytes, int index)
    throws Exception
  {
    return (short)((0xFF & bytes[index]) << 8 | (0xFF & bytes[(index + 1)]) << 0);
  }
  
  public static short toInt16Backwards(byte[] bytes, int index)
    throws Exception
  {
    return (short)((0xFF & bytes[(index + 1)]) << 8 | (0xFF & bytes[index]) << 0);
  }
  
  public static int toUInt16(Boolean b)
  {
    return b.booleanValue() ? 1 : 0;
  }
  
  public static byte ToByte(int i)
  {
    return (byte)i;
  }
  
  public static byte toByte(int i)
  {
    return ToByte(i);
  }
  
  public static byte toByte(Boolean b)
  {
    return (byte)(b.booleanValue() ? 1 : 0);
  }
  
  public static boolean ToBoolean(int i)
  {
    return i != 0;
  }
  
  public static double ToDouble(int i)
  {
    return i;
  }
  
  public static String ToString(byte[] b)
    throws UnsupportedEncodingException
  {
    return Extensions.byteToAsciiString(b);
  }
  
  public static int toInt32bb(byte[] bytes, int index)
    throws Exception
  {
    byte[] array = Arrays.copyOfRange(bytes, index, index + 4);
    ByteBuffer b = ByteBuffer.wrap(array);
    b.order(ByteOrder.LITTLE_ENDIAN);
    return b.getInt();
  }
  
 /* public static int toUInt32(byte[] bytes, int index)
    throws Exception
  {
    byte[] array = Arrays.copyOfRange(bytes, index, index + 4);
    ByteBuffer b = ByteBuffer.wrap(array);
    
    return b.getChar();
  }*/
  
  public static long toLongFromFourBytes(byte[] bytes, int index)
		    throws Exception
		  {
		    byte[] array = new byte[8]; 
		    //System.arraycopy(bytes, 0, array, 4, bytes.length);
		    array[4] = bytes[3];
		    array[5] = bytes[2];
		    array[6] = bytes[1];
		    array[7] = bytes[0];
		    ByteBuffer b = ByteBuffer.wrap(array);
		    
		    return b.getLong();
		  }
  public static long toLongFromUint32(byte[] bytes, int index)
		    throws Exception
		  {
	  byte[] array = new byte[8];
		// System.arraycopy(bytes, 0, array, 4, bytes.length);
		array[0] = (byte) 0;
		array[1] = (byte) 0;
		array[2] = (byte) 0;
		array[3] = (byte) 0;
		array[4] = bytes[index+0];
		array[5] = bytes[index+1];
		array[6] = bytes[index+2];
		array[7] = bytes[index+3];
		// ByteBuffer b = ByteBuffer.wrap(array);

		// return b.getLong();
		long l = ((bytes[index+3] & 0xFF) << 56) 
				| ((bytes[index+2] & 0xFF) << 48)
				| ((bytes[index+1] & 0xFF) << 40) 
				| ((bytes[index+0] & 0xFF) << 32)
				| ((array[3] & 0xFF) << 24) 
				| ((array[2] & 0xFF) << 16)
				| ((array[1] & 0xFF) << 8) 
				| ((array[0] & 0xFF) << 0);

		return l;
		  }
  public static int toInt32(byte[] bytes, int index)
    throws Exception
  {
    if (index + 3 >= bytes.length) {
      throw new Exception(
        "The length of the byte array must be at least 4 bytes long.");
    }
    return (0xFF & bytes[(index + 3)]) << 56 | 
      (0xFF & bytes[(index + 2)]) << 48 | 
      (0xFF & bytes[(index + 1)]) << 40 | (0xFF & bytes[index]) << 32;
  }
  
  public static int toInt32Forwards(byte[] bytes, int index)
    throws Exception
  {
    if (bytes.length <= 4) {
      throw new Exception(
        "The length of the byte array must be at least 4 bytes long.");
    }
    return (0xFF & bytes[index]) << 56 | (0xFF & bytes[(index + 1)]) << 48 | 
      (0xFF & bytes[(index + 2)]) << 40 | 
      (0xFF & bytes[(index + 3)]) << 32;
  }
  
  public static int ToUInt32(byte[] bytes, int index)
    throws Exception
  {
    return toInt32(bytes, index);
  }
  
  public static long toInt64(byte[] bytes, int index)
    throws Exception
  {
    return (0xFF & bytes[(index + 7)]) << 56 | 
      (0xFF & bytes[(index + 6)]) << 48 | 
      (0xFF & bytes[(index + 5)]) << 40 | 
      (0xFF & bytes[(index + 4)]) << 32 | 
      (0xFF & bytes[(index + 3)]) << 24 | 
      (0xFF & bytes[(index + 2)]) << 16 | 
      (0xFF & bytes[(index + 1)]) << 8 | 
      (0xFF & bytes[index]) << 0;
  }
  
  public static int ToUInt16(byte[] a, int index)
    throws Exception
  {
    int back = 0;
    back = (back & 0xFF00) + a[index] & 0xFF;
    return back;
  }
  
  public static int twoBytesToInt(byte[] b, int i)
  {
    return (b[(i + 1)] & 0xFF) << 8 | b[i] & 0xFF;
  }
  
  public static float toSingle(byte[] bytes, int index)
    throws Exception
  {
    return toInt32(bytes, index);
  }
  
  public static String toString(byte[] bytes)
    throws Exception
  {
    if (bytes == null) {
      throw new Exception("The byte array must have at least 1 byte.");
    }
    return new String(bytes);
  }
  
  public static String toString(byte[] b, int start, int len)
    throws Exception
  {
    byte[] subarray = Arrays.copyOfRange(b, start, start + len);
    return toString(subarray);
  }
  
  public static int ToInt32(byte b)
  {
    return b;
  }
  
  public static long toUInt64(byte[] bytes, int index)
    throws Exception
  {
    long value = 0L;
    for (int i = index; i < index + 8; i++) {
      value |= (0xFF & bytes[index]) << (i - index) * 8;
    }
    return value;
  }
}