package com.monnit.mine.BaseApplication.ExtensionMethods;

import com.monnit.mine.BaseApplication.BitConverter;

import java.io.UnsupportedEncodingException;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

public class Extensions
{
  public static Object CallStaticMethod(Class<?> type, String MethodName, Object[] param)
    throws RuntimeException
  {
    try
    {
      Class[] parameterTypes = new Class[param.length];
      int index = 0;
      Object[] arrayOfObject;
      int j = (arrayOfObject = param).length;
      for (int i = 0; i < j; i++)
      {
        Object o = arrayOfObject[i];
        parameterTypes[index] = o.getClass();
      }
      Method method = searchForMethod(type, MethodName, param.length);
      
      return method.invoke(null, param);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      throw new RuntimeException("Unable to call " + MethodName + " on " + 
        type.getName(), e);
    }
  }
  
  private static Method searchForMethod(Class<?> type, String name, int paramCount)
  {
    Method[] methods = type.getMethods();
    for (int i = 0; i < methods.length; i++) {
      if (methods[i].getName().equals(name))
      {
        Class[] types = methods[i].getParameterTypes();
        if (types.length == paramCount) {
          return methods[i];
        }
      }
    }
    return null;
  }
  
  public static Object CallStaticMethod(Class<?> type, String MethodName)
    throws Exception
  {
    try
    {
      Class[] params = new Class[0];
      Method method = type.getDeclaredMethod(MethodName, params);
      return method.invoke(null, params);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      throw new Exception("Unable to call " + MethodName + " on " + 
        type.getName(), e);
    }
  }
  
  public static Object getStaticPropertyValue(Class<?> type, String PropertyName)
    throws Exception
  {
    try
    {
      return type.getField(PropertyName).get(PropertyName);
    }
    catch (Exception e)
    {
      throw new Exception("Unable to find " + PropertyName + " on " + 
        type.getName(), e);
    }
  }
  
  public static String byteToAsciiString(byte[] b)
    throws UnsupportedEncodingException
  {
    String result = new String(b, "ASCII");
    return result;
  }
  
  public static String byteToAsciiString(byte[] b, int s, int e)
    throws UnsupportedEncodingException
  {
    String str = new String(b, "ASCII");
    return str.substring(s, e);
  }
  
  public static byte[] asciiStringToByte(String s)
  {
    return s.getBytes();
  }
  
  public static boolean stringIsNullOrEmpty(String s)
  {
    if (s == null) {
      return true;
    }
    if (s == "") {
      return true;
    }
    return false;
  }
  
  public static int ToMajorVersion(String s)
  {
    return Integer.parseInt(s.split("\\.")[0]);
  }
  
  public static void debug(String s)
  {
    debug(s, 1);
  }
  
  public static String hexStr(int x)
  {
    return hexStr(BitConverter.getBytes(x));
  }
  
  public static String hexStr(byte[] bb)
  {
    
    if (bb == null) {
      return "Null byte array";
    }
    StringBuilder sb = new StringBuilder();
    StringBuilder lb = new StringBuilder();
    byte[] arrayOfByte = bb;int j = bb.length;
    for (int i = 0; i < j; i++)
    {
      byte b = arrayOfByte[i];
      lb.append(String.format("%02d-", new Object[] { Integer.valueOf(i) }));
      i++;
      sb.append(String.format("%02X-", new Object[] { Byte.valueOf(b) }));
    }
    return "\n" + lb.toString() + "\n" + sb.toString();
  }
  
    public static Date firstDate()
	{
    	SimpleDateFormat sfd =new SimpleDateFormat("E MMM dd yyyy hh:mm:ss a");
    	sfd.setTimeZone(TimeZone.getTimeZone("UTC"));
		DateFormat df =  sfd;
		try
		{
			return df.parse("2010-01-01 00:00:00");
		}
		catch(ParseException ex)
		{
			debug(ex.getMessage());
		}
		
		return new Date();
	}
  
  public static void hexDebug(byte[] bb)
  {
    
    StringBuilder sb = new StringBuilder();
    byte[] arrayOfByte = bb;int j = bb.length;
    for (int i = 0; i < j; i++)
    {
      byte b = arrayOfByte[i];
      sb.append(String.format("%02X-", new Object[] { Byte.valueOf(b) }));
    }
    debug(sb.toString(), 14);
  }
  
  public static void hexDebug(byte[] bb, int level)
  {
    
    StringBuilder sb = new StringBuilder();
    byte[] arrayOfByte = bb;int j = bb.length;
    for (int i = 0; i < j; i++)
    {
      byte b = arrayOfByte[i];
      sb.append(String.format("%02X-", new Object[] { Byte.valueOf(b) }));
    }
    debug(sb.toString(), level);
  }
  
  public static void debug(String s, int level)
  {
    if (level != 54) {}
  }
  
  public static double ToCelsius(double Fahrenheit)
  {
	  return (Fahrenheit - 32.0)*(5.0 / 9.0);
  }
  
  public static double ToFahrenheit(double Celsius)
  {
	  return Celsius * (9.0/5.0) + 32.0;
  }
}