package com.monnit.mine.BaseApplication;

import com.monnit.mine.BaseApplication.ExtensionMethods.Extensions;
import com.monnit.mine.BaseApplication.applicationclasses.AGPSBase;
import com.monnit.mine.BaseApplication.applicationclasses.Activity_2Base;
import com.monnit.mine.BaseApplication.applicationclasses.AssetBase;
import com.monnit.mine.BaseApplication.applicationclasses.BatteryHealthBase;
import com.monnit.mine.BaseApplication.applicationclasses.ButtonLedBase;
import com.monnit.mine.BaseApplication.applicationclasses.Control_1Base;
import com.monnit.mine.BaseApplication.applicationclasses.CurrentZeroToOneFiftyAmpBase;
import com.monnit.mine.BaseApplication.applicationclasses.CurrentZeroToTwentyAmpBase;
import com.monnit.mine.BaseApplication.applicationclasses.DryContactBase;
import com.monnit.mine.BaseApplication.applicationclasses.DuctTemperatureBase;
import com.monnit.mine.BaseApplication.applicationclasses.FilteredPulseCounterBase;
import com.monnit.mine.BaseApplication.applicationclasses.FiveVoltDetectionBase;
import com.monnit.mine.BaseApplication.applicationclasses.HorizonPulseCounterBase;
import com.monnit.mine.BaseApplication.applicationclasses.HumiditySHT25Base;
import com.monnit.mine.BaseApplication.applicationclasses.LightBoolBase;
import com.monnit.mine.BaseApplication.applicationclasses.LiquidLevel24Base;
import com.monnit.mine.BaseApplication.applicationclasses.LiquidLevelBase;
import com.monnit.mine.BaseApplication.applicationclasses.LoggedActivityBase;
import com.monnit.mine.BaseApplication.applicationclasses.LuxBase;
import com.monnit.mine.BaseApplication.applicationclasses.OpenClosedBase;
import com.monnit.mine.BaseApplication.applicationclasses.PIRBase;
import com.monnit.mine.BaseApplication.applicationclasses.PulseCounterBase;
import com.monnit.mine.BaseApplication.applicationclasses.SmartRangerBase;
import com.monnit.mine.BaseApplication.applicationclasses.TemperatureBase;
import com.monnit.mine.BaseApplication.applicationclasses.TemperatureRTDBase;
import com.monnit.mine.BaseApplication.applicationclasses.TemperatureRTDLowBase;
import com.monnit.mine.BaseApplication.applicationclasses.VibrationBase;
import com.monnit.mine.BaseApplication.applicationclasses.VibrationMeterBase;
import com.monnit.mine.BaseApplication.applicationclasses.WaterBase;
import com.monnit.mine.BaseApplication.applicationclasses.WaterTemperatureBase;
import com.monnit.mine.BaseApplication.applicationclasses.WeightedActivityBase;
import com.monnit.mine.BaseApplication.enums.eApplicationProfileType;
import com.monnit.mine.Exceptions.NotImplementedException;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public abstract class _ApplicationBase
{
  public List<Datum> Data;
  
  public List<Datum> getData()
  {
    return null;
  }
  
  protected static double DefaultReportInterval = 120.0D;
  protected static double DefaultActiveStateInterval = 120.0D;
  protected static long DefaultChannelMask = 4294967295L;
  protected static int DefaultStandardMessageDelay = 50;
  protected static int DefaultTransmitIntervalLink = 2;
  protected static int DefaultTransmitIntervalTest = 126;
  protected static int DefaultTestTransmitCount = 1;
  public static int DefaultMaximumNetworkHops = 1;
  protected static int DefaultRetryCount = 2;
  protected static int DefaultRecovery = 2;
  protected static byte[] DefaultTimeOfDayActive = { -1, 
    -1, -1, -1, -1, -1, 
    -1, -1, -1, -1, -1, 
    -1 };
  protected static int DefaultMinimumCommunicationFrequency = 720;
  protected static int DefaultMeasurementsPerTransmission = 1;
  protected static int DefaultTransmitOffset = 0;
  protected static long DefaultHysteresis = 0L;
  protected static long DefaultMinimumThreshold = 2147483647L;
  protected static long DefaultMaximumThreshold = 2147483647L;
  protected static long DefaultCalibration1 = 2147483647L;
  protected static long DefaultCalibration2 = 2147483647L;
  protected static long DefaultCalibration3 = 2147483647L;
  protected static long DefaultCalibration4 = 2147483647L;
  protected static int DefaultEventDetectionType = Integer.MIN_VALUE;
  protected static int DefaultEventDetectionPeriod = Integer.MIN_VALUE;
  protected static int DefaultEventDetectionCount = Integer.MIN_VALUE;
  protected static int DefaultRearmTime = 0;
  protected static int DefaultBiStable = Integer.MIN_VALUE;
  public static Class<?>[] implementedSensors = {
    TemperatureBase.class, DryContactBase.class, WaterBase.class, 
    VibrationBase.class, OpenClosedBase.class, ButtonLedBase.class, 
    PIRBase.class, TemperatureRTDBase.class, Activity_2Base.class, 
    LoggedActivityBase.class, LightBoolBase.class, 
    HumiditySHT25Base.class, SmartRangerBase.class, 
    TemperatureRTDLowBase.class, PulseCounterBase.class, 
    WeightedActivityBase.class, WaterTemperatureBase.class, 
    AGPSBase.class, FilteredPulseCounterBase.class, 
    DuctTemperatureBase.class, HorizonPulseCounterBase.class };
  private static String[] implementedSensorsArray;
  
  public static void getImplementedSensors()
  {
    String[] sImpSensors = new String[implementedSensors.length];
    for (int i = 0; i < implementedSensors.length; i++)
    {
      String SSens = implementedSensors[i].toString();
      String[] parts = SSens.split("\\.");
      String className = parts[(parts.length - 1)];
      sImpSensors[i] = className;
    }
    implementedSensorsArray = sImpSensors;
  }
  
  private static boolean implementedSensorsInit = false;
  
  public static String[] implementedSensors()
  {
    if (implementedSensorsInit) {
      return implementedSensorsArray;
    }
    getImplementedSensors();
    implementedSensorsInit = true;
    
    return implementedSensorsArray;
  }
  
  public static int[] impNums = { 2, 3, 4, 5, 9, 11, 12, 19, 21, 23, 
    26, 27, 35, 36, 42, 43, 45, 46, 48, 59,60, 65, 66, 68, 71, 73, 84, 90,93,94 ,95 };
  
  public static Map<Integer, String> classMap()
  {
    Map<Integer, String> classes = new HashMap();
    String[] implemented = implementedSensors();
    for (int i = 0; i < implemented.length; i++) {
      classes.put(Integer.valueOf(impNums[i]), implemented[i]);
    }
    return classes;
  }
  
  public static Class<?> GetType(int applicationID)
    throws NotImplementedException
  {
    switch (applicationID)
    {
    case 2: 
      return TemperatureBase.class;
    case 3: 
      return DryContactBase.class;
    case 4: 
      return WaterBase.class;
    case 5: 
      return VibrationBase.class;
    case 9: 
      return OpenClosedBase.class;
    case 11: 
      return ButtonLedBase.class;
    case 12: 
      return Control_1Base.class;
    case 19: 
      return Activity_2Base.class;
    case 21: 
      return LuxBase.class;
    case 23: 
      return PIRBase.class;
    case 26:
    	return LiquidLevelBase.class;
    case 27: 
      return LightBoolBase.class;
    case 35: 
      return TemperatureRTDBase.class;
    case 36:
    	return LiquidLevel24Base.class;
    case 42: 
      return LoggedActivityBase.class;
    case 43: 
      return HumiditySHT25Base.class;
    case 45: 
      return SmartRangerBase.class;
    case 46: 
      return TemperatureRTDLowBase.class;
    case 48: 
      return PulseCounterBase.class;
    case 59:
    	return BatteryHealthBase.class;
    case 60: 
      return WeightedActivityBase.class;
    case 65: 
      return WaterTemperatureBase.class;
    case 66:
    	return AssetBase.class;
    case 68: 
      return AGPSBase.class;
    case 71:
    	return FiveVoltDetectionBase.class;
    case 73: 
      return FilteredPulseCounterBase.class;
    case 84: 
      return DuctTemperatureBase.class;
    case 90: 
      return HorizonPulseCounterBase.class;
    case 93:
    	return CurrentZeroToTwentyAmpBase.class;
    case 94:
    	return CurrentZeroToOneFiftyAmpBase.class;
    case 95: 
      return VibrationMeterBase.class;
    }
    throw new NotImplementedException("ApplicationID: " + applicationID + 
      " is not implemented");
  }
  
  public static _ApplicationBase CreateApplicationBase(int state, byte[] rawData, int applicationID)
    throws RuntimeException
  {
    Extensions.debug("ApplicationID: " + applicationID, 22);
    Object[] obs = { Integer.valueOf(state), rawData };
    Class<?> c = GetType(applicationID);
    return (_ApplicationBase)Extensions.CallStaticMethod(c, "Create", obs);
  }
  
  public static eApplicationProfileType ProfileType(int monnitApplicationID)
    throws Exception
  {
    Class<?> c = GetType(monnitApplicationID);
    return (eApplicationProfileType)Extensions.CallStaticMethod(c, 
      "getProfileType");
  }
}