package com.monnit.mine.BaseApplication.applicationclasses;

import com.monnit.mine.BaseApplication.BitConverter;
import com.monnit.mine.BaseApplication.Datum;
import com.monnit.mine.BaseApplication._ApplicationBase;
import com.monnit.mine.BaseApplication.enums.eApplicationProfileType;
import java.util.ArrayList;
import java.util.List;

public class AGPSBase
  extends _ApplicationBase
{
  public static long MonnitApplicationID = 68L;
  public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
  public double Lat;
  public double Lon;
  public int Altitude;
  public int Error;
  public List<Datum> Data;
  
  public List<Datum> getData()
  {
    if (this.Data == null)
    {
      this.Data = new ArrayList();
      this.Data.add(new Datum("Latitude", Double.valueOf(this.Lat)));
      this.Data.add(new Datum("Longitude", Double.valueOf(this.Lon)));
      this.Data.add(new Datum("Altitude", Integer.valueOf(this.Altitude)));
      this.Data.add(new Datum("Error", Integer.valueOf(this.Error)));
    }
    return this.Data;
  }
  
  public static AGPSBase Create(int state, byte[] rawData)
    throws Exception
  {
    AGPSBase obj = new AGPSBase();
    obj.Lat = BitConverter.toSingle(rawData, 0);
    obj.Lon = BitConverter.toSingle(rawData, 4);
    obj.Altitude = BitConverter.toInt32(rawData, 8);
    obj.Error = BitConverter.toInt32(rawData, 12);
    return obj;
  }
  
  public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
  public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
  public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
  public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
  public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
  public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
  public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
  public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
  public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
  public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
  public static long DefaultHysteresis = Long.MAX_VALUE;
  public static long DefaultMinimumThreshold = _ApplicationBase.DefaultMinimumThreshold;
  public static long DefaultMaximumThreshold = _ApplicationBase.DefaultMaximumThreshold;
  public static long DefaultCalibration1 = _ApplicationBase.DefaultCalibration1;
  public static long DefaultCalibration2 = _ApplicationBase.DefaultCalibration2;
  public static long DefaultCalibration3 = _ApplicationBase.DefaultCalibration3;
  public static long DefaultCalibration4 = _ApplicationBase.DefaultCalibration4;
  public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
  public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
  public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
  public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
  public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
  
  
}

