package com.monnit.mine.Encryption;

import com.monnit.mine.BaseApplication.ExtensionMethods.Extensions;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;

public class GW_Encryption
{
  public static SecretKey KeyGenerator()
  {
    KeyGenerator keygen = null;
    try
    {
      keygen = KeyGenerator.getInstance("AES");
    }
    catch (NoSuchAlgorithmException e)
    {
      e.printStackTrace();
    }
    keygen.init(128);
    SecretKey secretKey = keygen.generateKey();
    return secretKey;
  }
  
  public static byte[] IVGenerator()
  {
    byte[] iv = new byte[16];
    SecureRandom random = new SecureRandom();
    random.nextBytes(iv);
    return iv;
  }
  
  public static EncResult Encrypt128(byte[] PlainBytes, SecretKey Key, byte[] IV)
    throws Exception
  {
    Cipher cipher = Cipher.getInstance("AES/CBC/NoPadding");
    cipher.init(1, Key, new IvParameterSpec(IV));
    EncResult r = new EncResult();
    r.result = cipher.doFinal(PlainBytes);
    r.IV = cipher.getIV();
    return r;
  }
  
  public static byte[] Decrypt128(byte[] CipherBytes, SecretKey Key, byte[] IV)
    throws Exception
  {
    if (CipherBytes.length % 16 != 0) {
      Extensions.debug("Wrong packet size for decryption.", 30);
    }
    Cipher cipher = Cipher.getInstance("AES/CBC/NoPadding");
    cipher.init(2, Key, new IvParameterSpec(IV));
    return cipher.doFinal(CipherBytes);
  }
  
  public static class EncResult
  {
    public byte[] result;
    public byte[] IV;
    
    public EncResult()
    {
      this.result = null;
      this.IV = null;
    }
  }
}
