package com.monnit.mine.MonnitMineAPI;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

class InboundPacket
{
  private int _Security = 0;
  private int _GatewayID = 0;
  private int _Version = Integer.MIN_VALUE;
  private int _Power = Integer.MIN_VALUE;
  private int _Response = Integer.MIN_VALUE;
  private int _MessageCount = Integer.MIN_VALUE;
  private byte[] _Message = null;
  private Calendar _ReceivedDate = null;
  private Boolean _More = Boolean.valueOf(false);
  private int _Sequence = 0;
  public boolean isDuplicate = false;
  public byte[] Payload;
  
  public int getSecurity()
  {
    return this._Security;
  }
  
  public void setSecurity(int security)
  {
    this._Security = security;
  }
  
  public int getGatewayID()
  {
    return this._GatewayID;
  }
  
  public void setGatewayID(int gatewayID)
  {
    this._GatewayID = gatewayID;
  }
  
  public int getVersion()
  {
    return this._Version;
  }
  
  public void setVersion(int version)
  {
    this._Version = version;
  }
  
  public int getPower()
  {
    return this._Power;
  }
  
  public void setPower(int power)
  {
    this._Power = power;
  }
  
  public int getResponse()
  {
    return this._Response;
  }
  
  public void setResponse(int _Response)
  {
    this._Response = _Response;
  }
  
  public int getMessageCount()
  {
    return this._MessageCount;
  }
  
  public void setMessageCount(int _MessageCount)
  {
    this._MessageCount = _MessageCount;
  }
  
  public byte[] getMessage()
  {
    return this._Message;
  }
  
  public void setMessage(byte[] _Message)
  {
    this._Message = _Message;
  }
  
  public Calendar getReceivedDate()
  {
    return this._ReceivedDate;
  }
  
  public void setReceivedDate(Calendar _ReceivedDate)
  {
    this._ReceivedDate = _ReceivedDate;
  }
  
  public Boolean getMore()
  {
    return this._More;
  }
  
  public void setMore(Boolean more)
  {
    this._More = more;
  }
  
  public int getSequence()
  {
    return this._Sequence;
  }
  
  public void setSequence(int _Sequence)
  {
    this._Sequence = _Sequence;
  }
  
  public String toString()
  {
	  SimpleDateFormat  sdf = new SimpleDateFormat("E MMM dd yyyy hh:mm:ss a");
	  sdf.setTimeZone(TimeZone.getTimeZone("UTC"));
    return 
      sdf.format(getReceivedDate().getTime()) + " GatewayID: " + this._GatewayID + " MessageCount: " + this._MessageCount;
  }
  
  public byte[] getPayload()
  {
    if (this.Payload == null)
    {
      byte[] payload = new byte[getMessage().length - 16];
      System.arraycopy(getMessage(), 16, payload, 0, payload.length);
      this.Payload = payload;
      return payload;
    }
    return this.Payload;
  }
  
  public void setPayload(byte[] payload)
  {
    this.Payload = payload;
  }
}