package com.monnit.mine.MonnitMineAPI.enums;

import com.monnit.mine.BaseApplication._ApplicationBase;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

public enum eSensorApplication
{
  DC_Voltage_1V(1),  Temperature(2),  Dry_Contact(3),  Water_Detection(4),  Activity_Detection(5),  Magnetic_Presence(6),  Open_Closed(9),  Button(11),  Control_2_Output(12),  ID(14),  Accelerometer_Snapshot(15),  Accelerometer_Impact_Detection(16),  Activity_Number(19),  Accelerometer_Motion_Over_Time(20),  Lux(21),  Current_20mA(22),  Infared_Motion(23),  Flex(24),  Liquid_Tape_8(26),  Light_Detection(27),  Compass(28),  Humidity_Grains_Per_Pound(30),  AC_Voltage_500(32),  Vehicle_Detection(33),  CO_Gas(34),  High_Temperature(35),  Liquid_Tape_24(36),  Vehicle_Counter(39),  Vehicle_Speed(40),  Pressure(41),  Activity_Timer(42),  Humidity(43),  SmartRanger(45),  Low_Temperature(46),  Pulse_Counter_4_Input(47),  Pulse_Counter_1_Input(48),  Seat_Occupancy(51),  Air_Flow_Detection(52),  Current_1mA(55),  DC_Voltage_50V(59),  AC_Voltage_Detection(64),  Water_Temperature(65),  Asset(66),  Ultrasonic_Ranger(67),  Pulse_Counter_2_Input(69),  Resistance(70),  DC_Voltage_Detection(71),  DC_Voltage_5V(72),  Filtered_Pulse_Counter_1_Input(73),  DC_Voltage_10V(74),  Accelerometer_Tilt(75),  DuctTemperature(84), CurrentZeroToTwentyAmp(93),CurrentZeroToOneFiftyAmp(94), VibrationMeter(95);
  
  private final int _value;
  static Map<Integer, String> stringValues = new HashMap();
  
  public static Map<Integer, String> getStringValues()
  {
    stringValues.put(Integer.valueOf(1), "DC_Voltage_1V");
    stringValues.put(Integer.valueOf(2), "Temperature");
    stringValues.put(Integer.valueOf(3), "Dry_Contact");
    stringValues.put(Integer.valueOf(4), "Water_Detection");
    stringValues.put(Integer.valueOf(5), "Activity_Detection");
    stringValues.put(Integer.valueOf(6), "Magnetic_Presence");
    stringValues.put(Integer.valueOf(9), "Open_Closed");
    stringValues.put(Integer.valueOf(11), "Button");
    stringValues.put(Integer.valueOf(12), "Control_2_Output");
    stringValues.put(Integer.valueOf(14), "ID");
    stringValues.put(Integer.valueOf(15), "Accelerometer_Snapshot");
    stringValues.put(Integer.valueOf(16), "Accelerometer_Impact_Detection");
    stringValues.put(Integer.valueOf(19), "Activity_Number");
    stringValues.put(Integer.valueOf(20), "Accelerometer_Motion_Over_Time");
    stringValues.put(Integer.valueOf(21), "Lux");
    stringValues.put(Integer.valueOf(22), "Current_20mA");
    stringValues.put(Integer.valueOf(23), "Infared_Motion");
    stringValues.put(Integer.valueOf(24), "Flex");
    stringValues.put(Integer.valueOf(26), "Liquid_Tape_8");
    stringValues.put(Integer.valueOf(27), "Light_Detection");
    stringValues.put(Integer.valueOf(28), "Compass");
    stringValues.put(Integer.valueOf(30), "Humidity_Grains_Per_Pound");
    stringValues.put(Integer.valueOf(32), "AC_Voltage_500");
    stringValues.put(Integer.valueOf(33), "Vehicle_Detection");
    stringValues.put(Integer.valueOf(34), "CO_Gas");
    stringValues.put(Integer.valueOf(35), "High_Temperature");
    stringValues.put(Integer.valueOf(36), "Liquid_Tape_24");
    stringValues.put(Integer.valueOf(39), "Vehicle_Counter");
    stringValues.put(Integer.valueOf(40), "Vehicle_Speed");
    stringValues.put(Integer.valueOf(41), "Pressure");
    stringValues.put(Integer.valueOf(42), "Activity_Timer");
    stringValues.put(Integer.valueOf(43), "Humidity");
    stringValues.put(Integer.valueOf(45), "SmartRanger");
    stringValues.put(Integer.valueOf(46), "Low_Temperature");
    stringValues.put(Integer.valueOf(47), "Pulse_Counter_4_Input");
    stringValues.put(Integer.valueOf(48), "Pulse_Counter_1_Input");
    stringValues.put(Integer.valueOf(51), "Seat_Occupancy");
    stringValues.put(Integer.valueOf(52), "Air_Flow_Detection");
    stringValues.put(Integer.valueOf(55), "Current_1mA");
    stringValues.put(Integer.valueOf(59), "DC_Voltage_50V");
    stringValues.put(Integer.valueOf(60), "WeightedActivity");
    stringValues.put(Integer.valueOf(64), "AC_Voltage_Detection");
    stringValues.put(Integer.valueOf(65), "Water_Temperature");
    stringValues.put(Integer.valueOf(66), "Asset");
    stringValues.put(Integer.valueOf(67), "Ultrasonic_Ranger");
    stringValues.put(Integer.valueOf(69), "Pulse_Counter_2_Input");
    stringValues.put(Integer.valueOf(70), "Resistance");
    stringValues.put(Integer.valueOf(71), "DC_Voltage_Detection");
    stringValues.put(Integer.valueOf(72), "DC_Voltage_5V");
    stringValues.put(Integer.valueOf(73), "Filtered_Pulse_Counter_1_Input");
    stringValues.put(Integer.valueOf(74), "DC_Voltage_10V");
    stringValues.put(Integer.valueOf(75), "Accelerometer_Tilt");
    stringValues.put(Integer.valueOf(84), "DuctTemperature");
    stringValues.put(Integer.valueOf(90), "HorizonPulseCounter");
    stringValues.put(Integer.valueOf(93), "CurrentZeroToTwentyAmp");
    stringValues.put(Integer.valueOf(94), "CurrentZeroToOneFiftyAmp");
    stringValues.put(Integer.valueOf(95), "VibrationMeter");
    return stringValues;
  }
  
  public static String[] toValueArray()
  {
    String[] vals = new String[values().length];
    for (int i = 0; i < vals.length; i++) {
      vals[i] = values()[i].name();
    }
    Arrays.sort(vals);
    return vals;
  }
  
  public static String[] toImplementedValueArray()
  {
    Map<Integer, String> eVals = getStringValues();
   
    String[] AppNames = new String[_ApplicationBase.impNums.length];
   
    for (int i = 0; i <_ApplicationBase.impNums.length ; i++)
    {     
      AppNames[i] = ((String)eVals.get(Integer.valueOf(_ApplicationBase.impNums[i])));    
    }
    return AppNames;
  }
  
  private eSensorApplication(int value)
  {
    this._value = value;
  }
  
  public int Value()
  {
    return this._value;
  }
  
  public static eSensorApplication ToApplication(long v)
  {
    eSensorApplication[] arrayOfeSensorApplication;
    int j = (arrayOfeSensorApplication = values()).length;
    for (int i = 0; i < j; i++)
    {
      eSensorApplication egb = arrayOfeSensorApplication[i];
      if (egb.Value() == v) {
        return egb;
      }
    }
    return null;
  }
}
