package com.monnit.mine.WebPackages;

import com.monnit.mine.BaseApplication.ExtensionMethods.Extensions;
import com.monnit.mine.EventHandling.IAsyncResult;
import com.monnit.mine.MonnitMineAPI.MineUDPSocket;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.SocketException;

public class UdpClient
  extends Thread
{
  public int Port;
  public DatagramSocket socket;
  public DatagramSocket sendSocket;
  public InetSocketAddress addr;
  private MineUDPSocket mineudpsocket;
  private boolean initialized;
  private DatagramPacket packet;
  public IAsyncResult ar;
  public IPEndPoint clientEP;
  
  public UdpClient(int port, MineUDPSocket mus)
    throws SocketException, InterruptedException
  {
    this.Port = port;
    this.mineudpsocket = mus;
    
    this.addr = new InetSocketAddress(port);
    this.initialized = false;
    Extensions.debug("Constructed UdpClient.");
  }
  
  public void SendTo(byte[] message, IPEndPoint destination)
    throws IOException, InterruptedException
  {
    Extensions.debug(
    
      "Sending message to " + destination.IPAddress.toString() + ":" + destination.Port, 35);
    this.sendSocket = new DatagramSocket();
    
    DatagramPacket packet = new DatagramPacket(message, message.length, 
      destination.IPAddress, destination.Port);
    this.socket.send(packet);
    this.socket.close();
    
    Extensions.debug("Finished sending message.", 35);
  }
  
  public void run()
  {
    try
    {
      BeginReceive();
    }
    catch (Exception localException) {}
  }
  
  public void BeginReceive()
    throws Exception
  {
    Extensions.debug("Entering BeginReceive.", 35);
    Boolean failed = Boolean.valueOf(true);
    double startTime = System.currentTimeMillis();
    while (failed.booleanValue()) {
      try
      {
        this.socket = new DatagramSocket(this.Port);
        failed = Boolean.valueOf(false);
      }
      catch (Exception e)
      {
        Thread.sleep(10L);
        failed = Boolean.valueOf(true);
      }
    }
    double endTime = System.currentTimeMillis();
    Extensions.debug("Seconds waited between listening: " + 
      (endTime - startTime) / 1000.0D, 37);
    
    this.ar = new IAsyncResult(this);
    
    Extensions.debug("Waiting for packet.", 35);
    this.packet = receivePacket();
    this.ar.IsCompleted = true;
    
    this.mineudpsocket.HandleUDPRequestAsync(this.ar);
    Extensions.debug("Finishing BeginReceive.", 35);
  }
  
  public DatagramPacket EndReceive(IAsyncResult ar, IPEndPoint ipe)
    throws InterruptedException
  {
    Extensions.debug("Entering EndReceive.");
    this.clientEP = new IPEndPoint(this.packet.getAddress(), this.packet.getPort());
    DatagramPacket returnData = this.packet;
    this.packet = null;
    Extensions.debug("Exiting EndReceive.");
    return returnData;
  }
  
  public DatagramPacket receivePacket()
    throws IOException, InterruptedException
  {
    byte[] buffer = new byte[4096];
    DatagramPacket packet = new DatagramPacket(buffer, buffer.length);
    Extensions.debug("Waiting to receive packet on port " + this.Port);
    this.socket.receive(packet);
    Extensions.debug("Received packet!");
    return packet;
  }
  
  public void close()
  {
    try
    {
      this.socket.close();
    }
    catch (Exception localException) {}
  }
}
