
public class APNBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 0;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public double Lat { get; set; }
    public double Lon { get; set; }
    public double Altitude { get; set; }
    public double Error { get; set; }
    public override List<Datum> Data
    {
        get
        {
            return new List<Datum>() { new Datum("Latitude", Lat), new Datum("Longitude", Lon), new Datum("Altitude", Altitude), new Datum("Error", Error) };
        }
    }
    public static APNBase Create(int state, Byte[] rawData)
    {
        APNBase obj = new APNBase();
        obj.Lat = BitConverter.ToSingle(rawData, 0);
        obj.Lon = BitConverter.ToSingle(rawData, 4);
        obj.Altitude = BitConverter.ToSingle(rawData, 8);
        obj.Error = BitConverter.ToSingle(rawData, 12);
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = _ApplicationBase.DefaultMinimumThreshold;
    public static long DefaultMaximumThreshold = _ApplicationBase.DefaultMaximumThreshold;
    public static long DefaultCalibration1 = _ApplicationBase.DefaultCalibration1;
    public static long DefaultCalibration2 = _ApplicationBase.DefaultCalibration2;
    public static long DefaultCalibration3 = _ApplicationBase.DefaultCalibration3;
    public static long DefaultCalibration4 = _ApplicationBase.DefaultCalibration4;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
}

