
public class AccelerometerBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 15;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public Double Xval { get; set; }
    public Double Yval { get; set; }
    public Double Zval { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum> { new Datum("Xval", Xval), new Datum("Yval", Yval), new Datum("Zval", Zval) }; }
    }
    public static AccelerometerBase Create(int state, Byte[] rawData)
    {
        AccelerometerBase obj = new AccelerometerBase();
        obj.Xval = Convert.ToDouble(BitConverter.ToInt16(rawData, 0)) / 1000.0;
        obj.Yval = Convert.ToDouble(BitConverter.ToInt16(rawData, 0 + 2)) / 1000.0;
        obj.Zval = Convert.ToDouble(BitConverter.ToInt16(rawData, 0 + 4)) / 1000.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = UInt32.MaxValue;
    public static long DefaultMinimumThreshold = UInt32.MaxValue;
    public static long DefaultMaximumThreshold = UInt32.MaxValue;
    public static long DefaultCalibration1 = 0;
    public static long DefaultCalibration2 = 0;
    public static long DefaultCalibration3 = 0;
    public static long DefaultCalibration4 = 0;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] CalibrateFrame(long sensorID)
    {
        //Calibrate
        int length = 6;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration
        return api;
    }
}

