
public class AccelerometerTriggeredBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 16;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public bool ForceDetected { get; set; }
    public int Xval { get; set; }
    public int Yval { get; set; }
    public int Zval { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum> { new Datum("ForceDetected", ForceDetected), new Datum("Xval", Xval), new Datum("Yval", Yval), new Datum("Zval", Zval) }; }
    }
    public static AccelerometerTriggeredBase Create(int state, Byte[] rawData)
    {
        AccelerometerTriggeredBase obj = new AccelerometerTriggeredBase();
        if ((rawData[0] & 64) == 64)
        {
            obj.ForceDetected = true;
            obj.Xval = ((rawData[0] & 2) == 2) ? ((rawData[0] & 1) == 1 ? -1 extends 1) extends 0;
            obj.Yval = ((rawData[0] & 8) == 8) ? ((rawData[0] & 4) == 4 ? -1 extends 1) extends 0;
            obj.Zval = ((rawData[0] & 32) == 32) ? ((rawData[0] & 16) == 16 ? -1 extends 1) extends 0;
        }
        else
        {
            obj.ForceDetected = false;
            obj.Xval = 0;
            obj.Yval = 0;
            obj.Zval = 0;
        }
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = -_ApplicationBase.DefaultMinimumThreshold;
    public static long DefaultMaximumThreshold = _ApplicationBase.DefaultMaximumThreshold;
    public static long DefaultCalibration1 = 0x00120329;
    public static long DefaultCalibration2 = 0x00009E1E;
    public static long DefaultCalibration3 = 0X1;
    public static long DefaultCalibration4 = 0XFFFFFFFF;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static long Calibration1Value(long sensorID, Proformance proformance )
    {
        if (proformance.Equals(Proformance.Proformance_Power))
             return Convert.ToInt64(0x00120301);
        else
             return Convert.ToInt64(0x00120329);           
    }
    public enum Proformance
    {
        Proformance_Power = 0,
        Proformance_Battery = 1
    }
    public static long Calibration2Value(long calibration2, double gforce)
    {
        byte[] bytes = BitConverter.GetBytes(calibration2);
        double g = gforce;
        if (g > 8) g = 8;
        if (g < 0.063) g = 0.063;
        bytes[1] = Convert.ToByte(Convert.ToInt32(Math.Round(g / 0.063, 0)) + 128);
        return Convert.ToInt64(BitConverter.ToUInt32(bytes, 0));
    }
}

