
public class Accel_EspenBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 20;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public Double MaxXval { get; set; }
    public Double MaxYval { get; set; }
    public Double MaxZval { get; set; }
    public Double AvgXval { get; set; }
    public Double AvgYval { get; set; }
    public Double AvgZval { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("MaxXval", MaxXval), new Datum("MaxYval", MaxYval), new Datum("MaxZval", MaxZval), new Datum("AvgXval", AvgXval), new Datum("AvgYval", AvgYval), new Datum("AvgZval", AvgZval) }; }
    }
    public static Accel_EspenBase Create(int state, Byte[] rawData)
    {
        Accel_EspenBase obj = new Accel_EspenBase();
        obj.MaxXval = Convert.ToDouble(BitConverter.ToInt16(rawData, 0)) / 1000.0;
        obj.MaxYval = Convert.ToDouble(BitConverter.ToInt16(rawData, 0 + 2)) / 1000.0;
        obj.MaxZval = Convert.ToDouble(BitConverter.ToInt16(rawData, 0 + 4)) / 1000.0;
        obj.AvgXval = Convert.ToDouble(BitConverter.ToInt16(rawData, 0 + 6)) / 1000.0;
        obj.AvgYval = Convert.ToDouble(BitConverter.ToInt16(rawData, 0 + 8)) / 1000.0;
        obj.AvgZval = Convert.ToDouble(BitConverter.ToInt16(rawData, 0 + 10)) / 1000.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = UInt32.MaxValue;
    public static long DefaultMaximumThreshold = UInt32.MaxValue;
    public static long DefaultCalibration1 = 1;
    public static long DefaultCalibration2 = 20;
    public static long DefaultCalibration3 = 1;
    public static long DefaultCalibration4 = 0;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static long Calibration4Value(Mode mode)
    {
        return Convert.ToInt64(mode);
    }
    public enum Mode
    { 
        Normal_2G = 0,
        High_Pass_Filter_2G = 1, 
        Normal_4G = 2,
        High_Pass_Filter_4G = 3,
        Normal_8G = 4,
        High_Pass_Filter_8G = 5
    }
}

