
public class LuxBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 21;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public int LuxReading { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("LuxReading", LuxReading) }; }
    }
    public static LuxBase Create(int state, Byte[] rawData)
    {
        LuxBase obj = new LuxBase();
        obj.LuxReading = Convert.ToInt32(BitConverter.ToUInt16(rawData, 0));
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 1000;
    public static long DefaultCalibration1 = 727941;
    public static long DefaultCalibration2 = 1;
    public static long DefaultCalibration3 = 0;
    public static long DefaultCalibration4 = _ApplicationBase.DefaultCalibration4;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] CalibrateFrame(long sensorID, int actual, int filter, double temperatureCelcius)
    {
        int length = 12;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration
        UInt16 LuxTarget = Convert.ToUInt16(actual);
        UInt16 Xmittance = Convert.ToUInt16(filter);//1
        UInt16 TempTarget = Convert.ToUInt16(temperatureCelcius * 10);// 240
        byte[] buf = new Byte[6];
        Array.Copy(BitConverter.GetBytes(LuxTarget), 0, buf, 0, 2);
        Array.Copy(BitConverter.GetBytes(Xmittance), 0, buf, 2, 2);
        Array.Copy(BitConverter.GetBytes(TempTarget), 0, buf, 4, 2);
        Array.Copy(buf, 0, api, 6, 6);
        return api;
    }
}

