
public class LiquidLevelBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 26;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public Double Inch { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Inch", Inch) }; }
    }
    public static LiquidLevelBase Create(int state, Byte[] rawData)
    {
        LiquidLevelBase obj = new LiquidLevelBase();
        obj.Inch = Convert.ToDouble(BitConverter.ToInt16(rawData, 0)) / 100.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 800;
    public static long DefaultCalibration1 = 17000;
    public static long DefaultCalibration2 = 4500;
    public static long DefaultCalibration3 = 800;
    public static long DefaultCalibration4 = 100;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static Byte[] EmptyCalibration(long sensorID, double reading)
    {
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration
        api[6] = Convert.ToByte(0);
        api[7] = Convert.ToByte(reading *10);
        return api;
    }
    public static Byte[] FullCalibration(long sensorID, double reading)
    {
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration
        api[6] = Convert.ToByte(1);
        api[7] = Convert.ToByte(reading*10);
        return api;
    }
}

