
public class LightBoolBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 27;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public bool Light { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Light", Light) }; }
    }
    public static LightBoolBase Create(int state, Byte[] rawData)
    {
        LightBoolBase obj = new LightBoolBase();
        obj.Light = Convert.ToBoolean(rawData[0]);
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = -_ApplicationBase.DefaultMinimumThreshold;
    public static long DefaultMaximumThreshold = _ApplicationBase.DefaultMaximumThreshold;
    public static long DefaultCalibration1 = 0;
    public static long DefaultCalibration2 = 0;//Low Light auto set when calibration
    public static long DefaultCalibration3 = 0x3ff0;//16368 auto set when calibration
    public static long DefaultCalibration4 = _ApplicationBase.DefaultCalibration4;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] CalibrateFrame(long sensorID)
    {
        //Calibrate
        int length = 6;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration
        return api;
    }
    public int AwareLightOrDark(AwareState awareState)
    {
        return Convert.ToInt32(awareState);
    }
    public enum AwareState 
    {
        Aware_When_Light = 0,
        Aware_When_Dark = 1
    }
}

