
public class HAHumidityBase extends HumidityBase
{
    public static long MonnitApplicationID = 29;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Humidity", Hum), new Datum("Temperature", Temperature) }; }
    }
    public static HAHumidityBase Create(int state, Byte[] rawData)
    {
        HAHumidityBase obj = new HAHumidityBase();
        double TemperatureTicks = Convert.ToDouble(BitConverter.ToInt16(rawData, 0));
        double HumidityTicks = Convert.ToDouble(BitConverter.ToInt16(rawData, 0 + 2));
        obj.Temperature = CalcTemperature(TemperatureTicks);
        obj.Hum = CalcHumidity(HumidityTicks, obj.Temperature);
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = HumidityBase.DefaultMinimumThreshold;
    public static long DefaultMaximumThreshold = HumidityBase.DefaultMaximumThreshold;
    public static long DefaultCalibration1 = _ApplicationBase.DefaultCalibration1;
    public static long DefaultCalibration2 = _ApplicationBase.DefaultCalibration2;
    public static long DefaultCalibration3 = _ApplicationBase.DefaultCalibration3;
    public static long DefaultCalibration4 = _ApplicationBase.DefaultCalibration4;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
}

