
public class AC_DC_500VBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 32;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public double Voltage { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Voltage", Voltage) }; }
    }
    public static AC_DC_500VBase Create(int state, Byte[] rawData)
    {
        AC_DC_500VBase obj = new AC_DC_500VBase();
        obj.Voltage = Convert.ToDouble(BitConverter.ToUInt16(rawData, 0)) / 10d;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 5000;
    public static long DefaultCalibration1 = 40529;
    public static long DefaultCalibration2 = 0;
    public static long DefaultCalibration3 = 0;
    public static long DefaultCalibration4 = 0;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    //public static void CalibrateSensor(Sensor sensor, System.Collections.Specialized.NameValueCollection collection)
    //{
    //    int Mode = collection["mode"].ToInt();
    //    if (string.IsNullOrEmpty(collection["value"]))
    //    {
    //        sensor.Calibration2 = Mode;
    //    }
    //    else
    //    {
    //        DataMessage sdm = DataMessage.Load(collection["last"].ToLong());
    //        double OldVal = sdm.Data.ToDouble();
    //        if (OldVal != 0)
    //        {
    //            double Value = collection["value"].ToDouble();
    //            switch (Mode)
    //            {
    //                case 0extends // Volt AC RMS
    //                    Value = Value * Math.Sqrt(2);
    //                    OldVal = OldVal * Math.Sqrt(2);
    //                    break;
    //                case 1extends // Volt AC Peak to Peak
    //                    Value = Value / 2;
    //                    OldVal = OldVal / 2;
    //                    break;
    //                case 3extends // Volt DC US (60 Hz)
    //                case 4extends // Volt DC Europe (50 Hz)
    //                    break;
    //            }
    //            Value = Value * 10;
    //            OldVal = OldVal * 10;
    //            int ADCCode = ((OldVal * 100000) / sensor.Calibration1).ToInt();
    //            sensor.Calibration1 = ((Value * 100000) / ADCCode).ToLong();
    //        }
    //        //Calval3 PowerOptions Default 0 (0 none, 1 digital high SP2, 2 digital low SP2, 3 Amplifier SP9 Active Low)
    //        sensor.Calibration3 = collection["power"].ToInt();
    //        //Calval4 Delay Time (Miniseconds) Default 0 (0-30,000)
    //        sensor.Calibration4 = collection["delay"].ToInt();
    //        if (sensor.Calibration4 < 0) sensor.Calibration4 = 0;
    //        if (sensor.Calibration4 > 30000) sensor.Calibration4 = 30000;
    //    }
    //    sensor.Save();
    //}
    public static long Calibration1Value(Mode mode, double newValue, double oldValue, long calibration1) 
    {
        if (Convert.ToInt32(mode) == 0)
        {
            newValue = newValue * Math.Sqrt(2);
            oldValue = oldValue * Math.Sqrt(2);
        }
        else if (Convert.ToInt32(mode) == 1)
        {
            newValue = newValue / 2;
            oldValue = oldValue / 2;
        }
            newValue = newValue * 10;
            oldValue = oldValue * 10;
        int ADCCode = Convert.ToInt32((oldValue * 100000) / calibration1);
        return Convert.ToInt64((newValue * 100000) / ADCCode);
    }
    public static long Calibration2Value(Mode mode)
    {
        return Convert.ToInt64(mode);
    }
    public enum Mode
    { 
        Volt_AC_RMS = 0,
        Volt_AC_Peak_to_Peak = 1,
        Volt_DC_US_60_HZ = 3,
        Volt_DC_Europe_50_HZ = 4
    }
    public static int Calibration3Value(Power power) 
    {
        //Calval3 PowerOptions Default 0
        return Convert.ToInt32(power); 
    }
    public enum Power
    { 
        none=0, 
        digital_high_SP2=1, 
        digital_low_SP2=2,  
        Amplifier_SP9_Active_Low=3
    }
    public static long Calibration4Value(long delay) 
    {
        //Calval4 Delay Time (Miniseconds) Default 0 (0-30,000)
        if (delay < 0)
            return 0;
        else if (delay > 30000)
            return 30000;
        else
            return delay;
    }
}

