
public class VehiclePresenceBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 33;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public int Strength { get; set; }
    public int State { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Strength", Strength), new Datum("State", State) }; }
    }
    public static VehiclePresenceBase Create(int state, Byte[] rawData)
    {
        VehiclePresenceBase obj = new VehiclePresenceBase();
        byte[] bytes = new byte[2];
        //Pickup the Vehicle Count and Direction
        Array.Copy(rawData, 0, bytes, 0, 2);
        obj.Strength = BitConverter.ToUInt16(bytes, 0);
        obj.State = rawData[0] >> 4;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = 1; // debounce time (how many measurements to make state change) < 100
    public static long DefaultMaximumThreshold = 50; // Sensitivity 10 - 3000
    public static long DefaultCalibration1 = 1000; // use interval and mres 
    public static long DefaultCalibration2 = 3; //1 - 1800 rearm value seconds
    public static long DefaultCalibration3 = _ApplicationBase.DefaultCalibration3;
    public static long DefaultCalibration4 = _ApplicationBase.DefaultCalibration4;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
}

