
public class TemperatureRTDBase extends TemperatureBase
{
    public static long MonnitApplicationID = 35;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Temperature", Temp) }; }
    }
    public static TemperatureRTDBase Create(int state, Byte[] rawData)
    {
        TemperatureRTDBase obj = new TemperatureRTDBase();
        obj.Temp = Convert.ToDouble(BitConverter.ToInt16(rawData, 0)) / 10.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = -1000;
    public static long DefaultMaximumThreshold = 4500;
    public static long DefaultCalibration1 = 0;
    public static long DefaultCalibration2 = 10000;
    public static long DefaultCalibration3 = _ApplicationBase.DefaultCalibration3;
    public static long DefaultCalibration4 = _ApplicationBase.DefaultCalibration4;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] CalibrateFrame(long sensorID, double temp)
    {
        return TemperatureBase.CalibrateFrame(sensorID, temp);
    }
}

