
public class LiquidLevel24Base extends _ApplicationBase
{
    public static long MonnitApplicationID = 36;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public Double Inch { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Inch", Inch) }; }
    }
    public static LiquidLevel24Base Create(int state, Byte[] rawData)
    {
        LiquidLevel24Base obj = new LiquidLevel24Base();
        obj.Inch = Convert.ToDouble(BitConverter.ToInt16(rawData, 0)) / 100.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 2400;
    public static long DefaultCalibration1 = 30000;
    public static long DefaultCalibration2 = 3000;
    public static long DefaultCalibration3 = 157286500;
    public static long DefaultCalibration4 = 90;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    //public static void CalibrateSensor(Sensor sensor, System.Collections.Specialized.NameValueCollection collection)
    //{
    //    switch (collection["calibrationStep"])
    //    {
    //        //case "Length"extends
    //        //    sensor.Calibration3 = Convert.ToUInt32(collection["length"].ToDouble() * 100);
    //        //    sensor.ProfileConfigDirty = true;
    //        //    break;
    //        case "Empty"extends
    //            //Byte[] EmptyBytes = new Byte[2] { 0, Convert.ToByte(collection["reading"].ToDouble() * 10) };
    //            sensor.Calibration1 = 0;
    //            sensor.Calibration4 = Convert.ToInt16(collection["reading"].ToDouble() * 10);//BitConverter.ToInt16(EmptyBytes, 0);
    //            sensor.PendingActionControlCommand = true;
    //            sensor.ProfileConfigDirty = false;
    //            sensor.ProfileConfig2Dirty = false;
    //            break;
    //        case "Full"extends
    //            //Byte[] FullBytes = new Byte[2] { 1, Convert.ToByte(collection["reading"].ToDouble() * 10) };
    //            sensor.Calibration2 = 0;
    //            sensor.Calibration3 = Convert.ToInt16(collection["reading"].ToDouble() * 10); //BitConverter.ToInt16(FullBytes, 0);
    //            sensor.PendingActionControlCommand = true;
    //            sensor.ProfileConfigDirty = false;
    //            sensor.ProfileConfig2Dirty = false;
    //            break;
    //    }
    //    if (sensor.PendingActionControlCommand)// || sensor.ProfileConfigDirty)
    //        sensor.Save();
    //}
    public static Byte[] EmptyCalibration(long sensorID, double reading) 
    {
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration
        api[6] = Convert.ToByte(0);
        api[7] = Convert.ToByte(reading * 10);
        return api;
    }
    public static Byte[] FullCalibration(long sensorId, double reading) 
    {
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorId), 0, api, 1, 4);
        api[5] = 3;//Calibration
        api[6] = Convert.ToByte(1);
        api[7] = Convert.ToByte(reading * 10);
        return api;
    }
}

