
public class VehicleDetectorBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 39;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public int State { get; set; }
    public int Count { get; set; }
    public int Strength { get; set; }
    public int Duration { get; set; }
    public bool Direction { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("State", State), new Datum("Count", Count), new Datum("Strength", Strength), new Datum("Duration", Duration), new Datum("Direction", Direction) }; }
    }
    public static VehicleDetectorBase Create(int state, Byte[] rawData)
    {
        VehicleDetectorBase obj = new VehicleDetectorBase();
        byte[] bytes = new byte[2];
        obj.State = rawData[0] >> 4;
        Array.Copy(rawData, 0, bytes, 0, 2);
        if((bytes[1] & 0x80) == 0x80)
        {
            obj.Direction = true;
            bytes[1] &= 0x7F;
        } 
        obj.Count = BitConverter.ToUInt16(bytes, 0);
        Array.Copy(rawData, 0 + 2, bytes, 0, 2);
        obj.Strength = BitConverter.ToUInt16(bytes, 0);
        Array.Copy(rawData, 0 + 4, bytes, 0, 2);
        obj.Duration = BitConverter.ToUInt16(bytes, 0);
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = 0x0000FFFF;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 50;
    public static long DefaultCalibration1 = 50;
    public static long DefaultCalibration2 = _ApplicationBase.DefaultCalibration2;
    public static long DefaultCalibration3 = _ApplicationBase.DefaultCalibration3;
    public static long DefaultCalibration4 = _ApplicationBase.DefaultCalibration4;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] CalibrateFrame(long sensorID)
    {
        //Calibrate
        int length = 6;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration
        return api;
    }
}

