
public class VehicleSpeedBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 40;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public int State { get; set; }
    public int Strength { get; set; }
    public int TimeMs { get; set; }
    public bool Direction { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("State", State), new Datum("Strength", Strength), new Datum("TimeMs", TimeMs), new Datum("Direction", Direction) }; }
    }
    public static VehicleSpeedBase Create(int state, Byte[] rawData)
    {
        VehicleSpeedBase obj = new VehicleSpeedBase();
        byte[] bytes = new byte[2];
        obj.State = rawData[0] >> 4;
        Array.Copy(rawData, 0, bytes, 0, 2);
        if ((bytes[1] & 0x80) == 0x80)
        {
            obj.Direction = true;
            bytes[1] &= 0x7F;
        }
        obj.Strength = BitConverter.ToUInt16(bytes, 0);
        Array.Copy(rawData, 0 + 2, bytes, 0, 2);
        obj.TimeMs = BitConverter.ToUInt16(bytes, 0);
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = UInt32.MaxValue;// 0 -24 is sensorhood ping
    public static long DefaultMinimumThreshold = 0x2710;// 0 mean "trigger" 1 means count and report on heartbeat
    public static long DefaultMaximumThreshold = 50;// Sensitivity 10 - 3000
    public static long DefaultCalibration1 = 100;// Milliseconds (0 leaves behavior on Interval and Mres)
    public static long DefaultCalibration2 = 50;// communication lag
    public static long DefaultCalibration3 = _ApplicationBase.DefaultCalibration3;
    public static long DefaultCalibration4 = _ApplicationBase.DefaultCalibration4;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
}

