
public class Pressure_4to20maBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 41;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public Double Pressure { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Pressure", Pressure) }; }
    }
    public static Pressure_4to20maBase Create(int state, Byte[] rawData)
    {
        Pressure_4to20maBase obj = new Pressure_4to20maBase();
        obj.Pressure = Convert.ToDouble(BitConverter.ToUInt16(rawData, 0)) / 10.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 10000;
    public static long DefaultCalibration1 = 4000;
    public static long DefaultCalibration2 = 20000;
    public static long DefaultCalibration3 = 0;
    public static long DefaultCalibration4 = 1600;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] getCalibrationValue(long sensorID, HighLowCalibration calibrationType, int pressure)
    {
        if (pressure < 0)
            pressure = 0;
        else if (pressure > 5000)
            pressure = 5000;
        //Calibrate Temp
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = (byte)calibrationType; //Calibration (3 for low 4 for high)
        Array.Copy(BitConverter.GetBytes(Convert.ToInt16(pressure)), 0, api, 6, 2);
        return api;
    }
    public enum HighLowCalibration
    { 
        low = 3,
        high = 4
    }
}

