
public class HumiditySHT25Base extends _ApplicationBase
{
    public static long MonnitApplicationID = 43;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public double Hum { get; set; }
    public double Temperature { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum> { new Datum("Humidity", Hum), new Datum("Temperature", Temperature) }; }
    }
    public static HumiditySHT25Base Create(int state, Byte[] rawData)
    {
        HumiditySHT25Base obj = new HumiditySHT25Base();
        if ((state & 0xF0) == 0)
        {
            obj.Temperature = Convert.ToDouble(BitConverter.ToInt16(rawData, 0)) / 100d;
            obj.Hum = Convert.ToDouble(BitConverter.ToInt16(rawData, 0 + 2)) / 100d;
        }
        else
        {
            obj.Temperature = 0;
            obj.Hum = -100;
        }
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = 60536;
    public static long DefaultMaximumThreshold = 655375000;
    public static long DefaultCalibration1 = _ApplicationBase.DefaultCalibration1;
    public static long DefaultCalibration2 = _ApplicationBase.DefaultCalibration2;
    public static long DefaultCalibration3 = _ApplicationBase.DefaultCalibration3;
    public static long DefaultCalibration4 = _ApplicationBase.DefaultCalibration4;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    #region Reference Formulas from Manufacturer
    ////--------------------------------------------------------------------
    //float calc_dewpoint(float h, float t)
    ////--------------------------------------------------------------------
    //// calculates dew point
    //// inputextends   HumiditySHT25 [%RH], temperature [°C]
    //// outputextends  dew point [°C]
    //{
    //    float logEx, dew_point;
    //    logEx = 0.66077 + 7.5 * t / (237.3 + t) + (log10(h) - 2);
    //    dew_point = (logEx - 0.66077) * 237.3 / (0.66077 + 7.5 - logEx);
    //    return dew_point;
    //}
    
}

