
public class SmartRangerBase extends_ApplicationBase
{
    public static long MonnitApplicationID = 45;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public int DevCount { get; set; }
    public int RxMsgBySubnet { get; set; }
    public int UplinkFails { get; set; }
    public int MSGQueueCount { get; set; }
    public int SubNetChannel { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("DevCount", DevCount), new Datum("RxMsgBySubnet", RxMsgBySubnet), new Datum("UplinkFails", UplinkFails), new Datum("MSGQueueCount", MSGQueueCount), new Datum("SubNetChannel", SubNetChannel) }; }
    }
    public static SmartRangerBase Create(int state, Byte[] rawData)
    {
        SmartRangerBase obj = new SmartRangerBase();
        obj.DevCount = BitConverter.ToUInt16(rawData, 0);
        obj.RxMsgBySubnet = BitConverter.ToUInt16(rawData, 0 + 2);
        obj.UplinkFails = BitConverter.ToUInt16(rawData, 0 + 4);
        obj.MSGQueueCount = BitConverter.ToUInt16(rawData, 0 + 6);
        obj.SubNetChannel = (int)rawData[0 + 8];
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = 100;
    public static int DefaultTransmitIntervalLink = 101;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = 1;
    public static int DefaultRecovery = 10;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static double ActiveStateInterval = 1;
    public static double ReportInterval = 1;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = 0;
    public static long DefaultMinimumThreshold = 3;
    public static long DefaultMaximumThreshold = 20;
    public static long DefaultCalibration1 = _ApplicationBase.DefaultCalibration1;
    public static long DefaultCalibration2 = _ApplicationBase.DefaultCalibration2;
    public static long DefaultCalibration3 = 86400;
    public static long DefaultCalibration4 = 6;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] CalibrateFrame(long sensorID, double temp)
    {
        //Calibrate Temp
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = Convert.ToByte(temp);
        return api;
    }
    public static bool IgnoreActiveStateInSimpleEditScreen = true;
}

