
public class AirFlowBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 52;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public double KOhms { get; set; }
    public bool Flowing { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("KOhms", KOhms), new Datum("Flowing", Flowing) }; }
    }
    public static AirFlowBase Create(int state, Byte[] rawData)
    {
        AirFlowBase obj = new AirFlowBase();
        obj.Flowing = Convert.ToBoolean(rawData[0]);
        obj.KOhms = Convert.ToDouble(BitConverter.ToUInt32(rawData, 0 + 1)) / 1000.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = 1000;
    public static long DefaultMaximumThreshold = 9000;
    public static long DefaultCalibration1 = 1000;
    public static long DefaultCalibration2 = 2;
    public static long DefaultCalibration3 = 1;
    public static long DefaultCalibration4 = 1000;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
}

