
public class Current_CT1MABase extends _ApplicationBase
{
    public static long MonnitApplicationID = 55;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public Double Current { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Current", Current) }; }
    }
    public static Current_CT1MABase Create(Byte[] sdm, int startIndex)
    {
        Current_CT1MABase obj = new Current_CT1MABase();
        obj.Current = Convert.ToDouble(BitConverter.ToUInt16(sdm, startIndex)) / 10.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 65000;
    public static long DefaultCalibration1 = 2033;
    public static long DefaultCalibration2 = 2000;
    public static long DefaultCalibration3 = 200;
    public static long DefaultCalibration4 = 5;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    //public static void CalibrateSensor(Sensor sensor, System.Collections.Specialized.NameValueCollection collection)
    //{
    //    sensor.Calibration1 = (collection["actual"].ToDouble() * 10).ToLong();
    //    sensor.ProfileConfigDirty = false;
    //    sensor.ProfileConfig2Dirty = false;
    //    sensor.PendingActionControlCommand = true;
    //    sensor.Save();
    //}
    public static byte[] CalibrateFrame(long sensorID, int current)
    {
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration
        Array.Copy(BitConverter.GetBytes(Convert.ToInt16(current)), 0, api, 6, 2);
        return api;
    }
    public static long Calibration1Value(double amps)
    {
        return Convert.ToInt64(amps * 10);
    }
}

