
public class Gas_NO2Base extends _ApplicationBase
{
    public static long MonnitApplicationID = 57;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public double Temp { get; set; }
    public double PPM { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Temperature", Temp), new Datum("PPM", PPM) }; }
    }
    public static Gas_NO2Base Create(int state, Byte[] rawData)
    {
        Gas_NO2Base obj = new Gas_NO2Base();
        obj.Temp = BitConverter.ToInt16(rawData, 0) / 10.0;
        obj.PPM = BitConverter.ToUInt16(rawData, 0 + 2) / 100.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static double DefaultActiveStateInterval = 1;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = UInt32.MaxValue;
    public static long DefaultMinimumThreshold = 0x0000FF38;
    public static long DefaultMaximumThreshold = 0x07D001F4;
    public static long DefaultCalibration1 = 100000;
    public static long DefaultCalibration2 = 0;
    public static long DefaultCalibration3 = 0x00FA06E0;
    public static long DefaultCalibration4 = 166865;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] CalibrationFrameTemperature(long sensorID, double temp)
    {
        //Calibrate Temp
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration TEMP
        Array.Copy(BitConverter.GetBytes(Convert.ToUInt16(temp * 10)), 0, api, 6, 2);
        return api;
    }
    public static byte[] CalibrationFrameZero(long sensorID)
    {
        //Calibrate 0 PPM
        int length = 6;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 4;//Calibration 0ppm
        return api;
    }
    public static byte[] CalibrationFrameSpan(long sensorID, double span)
    {
        //Calibrate Span
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 5;//Calibration Span
        Array.Copy(BitConverter.GetBytes(Convert.ToUInt16(span * 100)), 0, api, 6, 2);
        return api;
    }
}

