
public class WeightedActivityBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 60;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public int Weight { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Weight", Weight) }; }
    }
    public static WeightedActivityBase Create(int state, Byte[] rawData)
    {
        WeightedActivityBase obj = new WeightedActivityBase();
        obj.Weight = (int)rawData[0];
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = 8;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = 2;
    public static int DefaultRecovery = 2;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static double DefaultReportInterval = 10;
    public static double DefaultActiveStateInterval = 10;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = 0;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 0;
    public static long DefaultCalibration1 = 60;
    public static long DefaultCalibration2 = 1;
    public static long DefaultCalibration3 = 126;
    public static long DefaultCalibration4 = 15;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] ClearStoredDataFrame(long sensorID)
    {
        //Calibrate
        int length = 6;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 201;//Action control command of 201 will clear any data-log history from sensor.
        return api;
    }
    public static byte[] SetDataLogDeliveryPriority(long sensorID, bool highPriority)
    {
        //Calibrate
        int length = 6;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        if(highPriority)
            api[5] = 202;//Action control command of 202 will set Data Log Delivery Priority to High.
        else
            api[5] = 203;//Action control command of 203 will set Data Log Delivery Priority to Low.
        return api;
    }
    public static byte[] SetStudyMode(long sensorID, bool startStudy)
    {
        //Calibrate
        int length = 6;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        if (startStudy)
            api[5] = 204;//Action control command of 204 will set sensor to Study On or Start Study.
        else
            api[5] = 205;//Action control command of 205 will set sensor to Study Off or Stop Study.
        return api;
    }
}

