
public class GPSBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 63;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public bool Valid { get; set; }
    public double Lat { get; set; }
    public double Lon { get; set; }
    public double Speed { get; set; }
    public double Bearing { get; set; }
    public double Altitude { get; set; }
    public int Satalites { get; set; }
    public int Error { get; set; }
    public override List<Datum> Data
    {
        get
        {
            return new List<Datum>() { new Datum("Valid", Valid), new Datum("Latitude", Lat), new Datum("Longitude", Lon), new Datum("Speed", Speed), 
            new Datum("Bearing", Bearing), new Datum("Altitude", Altitude), new Datum("Satalites", Satalites), new Datum("Error", Error) };
        }
    }
    public static GPSBase Create(int state, Byte[] rawData)
    {
        GPSBase obj = new GPSBase();
        obj.Lat = BitConverter.ToSingle(rawData, 0);
        obj.Lon = BitConverter.ToSingle(rawData, 0 + 4);
        obj.Speed = BitConverter.ToUInt16(rawData, 0 + 8) / 10.0;
        obj.Bearing = BitConverter.ToUInt16(rawData, 0 + 10) / 10.0;
        obj.Altitude = BitConverter.ToUInt16(rawData, 0 + 12) / 10.0;
        obj.Satalites = rawData[0 + 14];
        obj.Error = rawData[0 + 15];
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = UInt32.MaxValue;
    public static long DefaultMinimumThreshold = _ApplicationBase.DefaultMinimumThreshold;
    public static long DefaultMaximumThreshold = _ApplicationBase.DefaultMaximumThreshold;
    public static long DefaultCalibration1 = _ApplicationBase.DefaultCalibration1;
    public static long DefaultCalibration2 = _ApplicationBase.DefaultCalibration2;
    public static long DefaultCalibration3 = _ApplicationBase.DefaultCalibration3;
    public static long DefaultCalibration4 = _ApplicationBase.DefaultCalibration4;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
}

