
public class UltrasonicBase extends _ApplicationBase
{
   public static long MonnitApplicationID = 67;
   public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
   public Double Distance { get; set; }
   public override List<Datum> Data
   {
       get
       {
           return new List<Datum>() { new Datum("Distance", Distance) };
       }
   }
   public static UltrasonicBase Create(int state, Byte[] rawData)
   {
       UltrasonicBase obj = new UltrasonicBase();
       if ((state & 0x08) == 0x08)
       {
           obj.Distance = 0xFFFFFFFF;
       }
       if ((state & 0x04) == 0x04)
       {
           obj.Distance = 0xFFFFFFFE;
       }
       else
       {
           obj.Distance = BitConverter.ToUInt16(rawData, 0);
       }
       return obj;
   }
   
   public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
   public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
   public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
   public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
   public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
   public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
   public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
   public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
   public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
   public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
   public static long DefaultHysteresis = 0;
   public static long DefaultMinimumThreshold = 0;
   public static long DefaultMaximumThreshold = 4500;
   public static long DefaultCalibration1 = 1000;
   public static long DefaultCalibration2 = 200;
   public static long DefaultCalibration3 = 0xFFFFFFFF;
   public static long DefaultCalibration4 = 0xFFFFFFFF;
   public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
   public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
   public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
   public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
   public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
   
   public static byte[] CalibrateFrame(long sensorID, double distance)
   {
       //Calibrate Ultrasonic
       int length = 8;
       byte[] api = new Byte[length];
       api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
       Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
       api[5] = 3;//Calibration
       Array.Copy(BitConverter.GetBytes(Convert.ToInt16(distance)), 0, api, 6, 2);
       return api;
   }
}

