
public class DualPulseCounterBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 69;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public UInt32 Count1 { get; set; }
    public UInt32 Count2 { get; set; }
    public UInt32 ActivityTimer { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Count1", Count1), new Datum("Count2", Count2), new Datum("ActivityTimer", ActivityTimer) }; }
    }
    public static byte[] CalibrateFrame(long sensorID)
    {
        //Calibrate Temp
        int length = 6;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration
        return api;
    }
    public static DualPulseCounterBase Create(int state, Byte[] rawData)
    {
        DualPulseCounterBase obj = new DualPulseCounterBase();
        obj.Count1 = BitConverter.ToUInt32(rawData, 0);
        obj.Count2 = BitConverter.ToUInt32(rawData, 0 + 2);
        obj.ActivityTimer = BitConverter.ToUInt32(rawData, 0 + 4);
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = 1;
    public static int DefaultTransmitOffset = 0;
    public static long DefaultHysteresis = 0;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 0xFFFFFFFF;
    public static long DefaultCalibration1 = 1;
    public static long DefaultCalibration2 = 5;
    public static long DefaultCalibration3 = 1;
    public static long DefaultCalibration4 = 1;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
}

