
public class ResistanceBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 70;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    /// <summary>
    /// Error Codes
    /// -999.7 -> Hardware Failure (Empty)
    /// -999.8 -> Hardware Failure (Short)
    /// -999.9 -> No Sensor Detected
    /// -1000 -> Short Detected, Reset Battery
    /// 125 -> Short Detected, Reset Battery
    /// </summary>
    public Double Resistance { get; set; }
    public override List<Datum> Data
    {
        get
        {
            return new List<Datum>() { new Datum("Resistance", Resistance) };
        }
    }
    public static ResistanceBase Create(int state, Byte[] rawData)
    {
        ResistanceBase obj = new ResistanceBase();
        obj.Resistance = Convert.ToDouble(BitConverter.ToUInt32(rawData, 0)) / 10.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 1450000;
    public static long DefaultCalibration1 = 3600;
    public static long DefaultCalibration2 = 100000;
    public static long DefaultCalibration3 = 542000;
    public static long DefaultCalibration4 = 10000;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] CalibrateFrame(long sensorID, double calibrateTo)
    {
        //Calibrate Temp
        int length = 10;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration
        Array.Copy(BitConverter.GetBytes(Convert.ToUInt32(calibrateTo * 10)), 0, api, 6, 4);
        return api;
    }
}

