
public class ZeroToFiveVoltBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 72;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public Double Volts { get; set; }
    public override List<Datum> Data
    {
        get
        {
            return new List<Datum>() { new Datum("Volts", Volts) };
        }
    }
    public static ZeroToFiveVoltBase Create(int state, Byte[] rawData)
    {
        ZeroToFiveVoltBase obj = new ZeroToFiveVoltBase();
        obj.Volts = BitConverter.ToUInt16(rawData, 0) / 1000.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = _ApplicationBase.DefaultHysteresis;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 5500;
    public static long DefaultCalibration1 = 53240;// WiFi Should be set to 3200
    public static long DefaultCalibration2 = 0;
    public static long DefaultCalibration3 = 0;//Calval3 PowerOptions Default 0 (0 none, 1 digital high SP2, 2 digital low SP2, 3 Amplifier SP9 Active Low)
    public static long DefaultCalibration4 = 0;//Calval4 Delay Time (Miniseconds) Default 0 (0-30,000)
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    /// <summary>
    /// Firmware must be 2.0.1 or newer
    /// </summary>
    /// <param name="sensorID"></param>
    /// <param name="observed"></param>
    /// <param name="actuall"></param>
    /// <returns></returns>
    public static long Calibration1Value(long sensorID, long currentCalibration1, double observed, double actual, bool isWiFi)
    {
        int Observed = Convert.ToInt32(observed * 1000);
        int Actual = Convert.ToInt32(actual * 1000);
        if (Observed > 0 && Actual > 0)
        {
            if (isWiFi)
            {
                int ADCCode = Convert.ToInt32(Observed * 1000000 / currentCalibration1);
                return Actual * 1000000 / ADCCode;
            }
            else
            {
                int ADCCode = Convert.ToInt32(Observed * 20470 / currentCalibration1);
                return Actual * 20470 / ADCCode;
            }
        }
        return currentCalibration1;
    }
}

