
public class GridEyeBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 77;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public UInt16 OccupancyCount { get; set; }
    public UInt16 InCount { get; set; }
    public UInt16 OutCount { get; set; }
    public override List<Datum> Data
    {
        get
        {
            return new List<Datum>() { new Datum("Occupancy Count", OccupancyCount), new Datum("In Count", InCount), new Datum("Out Count", OutCount) };
        }
    }
    public static GridEyeBase Create(int state, Byte[] rawData)
    {
        GridEyeBase obj = new GridEyeBase();
       // int State = rawData[0];
        obj.OccupancyCount = BitConverter.ToUInt16(rawData,0);
        obj.InCount = BitConverter.ToUInt16(rawData,2);
        obj.OutCount = BitConverter.ToUInt16(rawData,4);
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = 0xFFFFFFFF;}}
    public static long DefaultMinimumThreshold = 600;
    public static long DefaultMaximumThreshold = 65535;
    public static long DefaultCalibration1 = 88;
    public static long DefaultCalibration2 = 160;
    public static long DefaultCalibration3 = 1500;
    public static long DefaultCalibration4 = 8;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
}

