
public class LoggedMultiPulseBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 80;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public int Count1 { get; set; }
    public int Count2 { get; set; }
    public int Count3 { get; set; }
    public int Count4 { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Count1", Count1), new Datum("Count2", Count2), new Datum("Count3", Count3), new Datum("Count4", Count4) }; }
    }
    public static LoggedMultiPulseBase Create(int state, Byte[] rawData)
    {
        LoggedMultiPulseBase obj = new LoggedMultiPulseBase();
        obj.Count1 = BitConverter.ToUInt16(rawData, 0);
        obj.Count2 = BitConverter.ToUInt16(rawData, 0 + 2);
        obj.Count3 = BitConverter.ToUInt16(rawData, 0 + 4);
        obj.Count4 = BitConverter.ToUInt16(rawData, 0 + 6);
        return obj;
    }
    public static byte[] getCalibrationValue(long sensorID)
    {
        //Calibrate Temp
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = (byte)3; //Calibration (3 for reset data log)
        return api;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = 0;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = 0;
    public static long DefaultMinimumThreshold = 0xFFFFFFFF;
    public static long DefaultMaximumThreshold = 0xFFFFFFFF;
    public static long DefaultCalibration1 = 1;
    public static long DefaultCalibration2 = 0xFFFFFFFF;
    public static long DefaultCalibration3 = 0;
    public static long DefaultCalibration4 = 5000;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
}

