
public class CTPowerBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 81;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public double Power { get; set; }
    public double AvgPower { get; set; }
    public double Volts { get; set; }
    public double Current { get; set; }
    public double Freq { get; set; }
    public double PowerFactor { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Power Usage", Power), new Datum("AvgPower", AvgPower), new Datum("Volts", Volts), new Datum("Current", Current), new Datum("Freq", Freq), new Datum("Power Factor", PowerFactor) }; }
    }
    public static CTPowerBase Create(int state, Byte[] rawData)
    {
        CTPowerBase obj = new CTPowerBase();
        obj.Power = (BitConverter.ToUInt32(rawData, 1) / 1000d);
        obj.AvgPower = (BitConverter.ToInt32(rawData, 5) / 1000d);
        obj.Volts = (BitConverter.ToUInt16(rawData, 9) / 10d);
        obj.Current = (BitConverter.ToUInt16(rawData, 11) / 100d);
        obj.Freq = rawData[13];
        obj.PowerFactor = (rawData[14] / 100d);
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = 0x00007D01;
    public static long DefaultMinimumThreshold = 0xFFFFFFFF;
    public static long DefaultMaximumThreshold = 0xFFFFFFFF;
    public static long DefaultCalibration1 = 155660;
    public static long DefaultCalibration2 = 1613;
    public static long DefaultCalibration3 = 100;
    public static long DefaultCalibration4 = 20;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] CalibrateFrame(long sensorID, double voltage)
    {
        //Calibrate Temp
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = 3;//Calibration
        Array.Copy(BitConverter.GetBytes(Convert.ToInt16(voltage * 1000)), 0, api, 6, 2);
        return api;
    }
}

