
public class PressureNPSIBase extends _ApplicationBase
{
    public static long MonnitApplicationID = 79;
    public static eApplicationProfileType ProfileType = eApplicationProfileType.Interval;
    public Double Pressure { get; set; }
    public override List<Datum> Data
    {
        get { return new List<Datum>() { new Datum("Pressure", Pressure) }; }
    }
    public static PressureNPSIBase Create(int state, Byte[] rawData)
    {
        PressureNPSIBase obj = new PressureNPSIBase();
        obj.Pressure = Convert.ToDouble(BitConverter.ToUInt16(rawData, 0)) / 10.0;
        return obj;
    }
    
    public static long DefaultChannelMask = _ApplicationBase.DefaultChannelMask;
    public static int DefaultStandardMessageDelay = _ApplicationBase.DefaultStandardMessageDelay;
    public static int DefaultTransmitIntervalLink = _ApplicationBase.DefaultTransmitIntervalLink;
    public static int DefaultTransmitIntervalTest = _ApplicationBase.DefaultTransmitIntervalTest;
    public static int DefaultTestTransmitCount = _ApplicationBase.DefaultTestTransmitCount;
    public static int DefaultRetryCount = _ApplicationBase.DefaultRetryCount;
    public static int DefaultRecovery = _ApplicationBase.DefaultRecovery;
    public static byte[] DefaultTimeOfDayActive = _ApplicationBase.DefaultTimeOfDayActive;
    public static int DefaultMeasurementsPerTransmission = _ApplicationBase.DefaultMeasurementsPerTransmission;
    public static int DefaultTransmitOffset = _ApplicationBase.DefaultTransmitOffset;
    public static long DefaultHysteresis = 0;
    public static long DefaultMinimumThreshold = 0;
    public static long DefaultMaximumThreshold = 500;
    public static long DefaultCalibration1 = 500;
    public static long DefaultCalibration2 = 4500;
    public static long DefaultCalibration3 = 1000;
    public static long DefaultCalibration4 = 500;
    public static int DefaultEventDetectionType = _ApplicationBase.DefaultEventDetectionType;
    public static int DefaultEventDetectionPeriod = _ApplicationBase.DefaultEventDetectionPeriod;
    public static int DefaultEventDetectionCount = _ApplicationBase.DefaultEventDetectionCount;
    public static int DefaultRearmTime = _ApplicationBase.DefaultRearmTime;
    public static int DefaultBiStable = _ApplicationBase.DefaultBiStable;
    
    public static byte[] getCalibrationValue(long sensorID, double psi)
    {
        UInt16 tempPressure = Convert.ToUInt16(psi);
        //Calibrate Temp
        int length = 8;
        byte[] api = new Byte[length];
        api[0] = 0x74;// MSAPI.CMD_APPCMD_REQUEST;
        Array.Copy(BitConverter.GetBytes(sensorID), 0, api, 1, 4);
        api[5] = tempPressure == 0 ? (byte)3 extends (byte)4; //Calibration (3 for Zero 4 for Span)
        if (tempPressure != 0)
            Array.Copy(BitConverter.GetBytes(tempPressure), 0, api, 6, 2);
        return api;
    }
}

